# ssd1306-bme280.py testet BME280-Ausgabe an 1.3' OLED-Display an Fipy
# Didi Lamken 7.7.2019

import machine, time, ssd1306, bme280
from machine import Pin,I2C

addrOled    =  60    # 0x3c
addrBME280  = 119    # 0x76
hSize       =  32    #  display heigh in pixels
wSize       = 128    #  display width in pixels

oledIsConnected = False
bmeIsConnected  = False
temp  = 0
pa    = 0
hum   = 0

#i2c = I2C(scl=Pin(22), sda=Pin(21), freq=100000)    # ESP32 DevKit
#                              SDA    SCL
i2c = I2C(0, I2C.MASTER, pins=('P9', 'P10'))         # PyCom FiPy

# Scan i2c bus and check if BME280 and OLED display are connected
print('Scan i2c bus...')
devices = i2c.scan()
if len(devices) == 0:
  print("No i2c device !")
else:
  print('i2c devices found:',len(devices))
  for device in devices:
    if device == addrOled:
      oledIsConnected = True
      print('Found OLED   address 0x{0:2X} hex = {0:3d} dez'.format(device, device))
      #print(device)
    if device == addrBME280:
      bmeIsConnected = True
      #print(device)
      print('Found BME280 address 0x{0:2X} hex = {0:3d} dez'.format(device, device))

if bmeIsConnected:
    print("Read BME280 sensor ...")
    bme = bme280.BME280(i2c=i2c,address=addrBME280)
    temp,pa,hum = bme.values
    print("Temperatur   = ", temp)
    print("Luftdruck    = ", pa)
    print("Luftfeuchte  = ", hum)

if oledIsConnected:
    oled = ssd1306.SSD1306_I2C(128,64,i2c)
    oled.contrast(200)
    oled.fill(0)
    oled.text("OLED Displaytest", 0,  0)
    oled.show()

time.sleep(1)
for cycles in range(5):
    print('Count: ', cycles)

    if oledIsConnected:
        oled.fill(0)
        oled.text("BOB BME280 OLED" ,   0,  0)
        teststr = str(cycles)
        oled.text("Count    " +teststr, 0, 20)
        if bmeIsConnected:
            temp,pa,hum = bme.values
        else:
            print('kein BME280 vorhanden')
            temp = '00.0 C'
            pa   = '0000.0 hPa'
            hum  = '00.0 %'
        oled.text("Temp.   " +temp,    0, 30)
        oled.text("Druck "   +pa,      0, 40)
        oled.text("Feuchte " +hum,     0, 50)
        oled.show()
    else:
        print('kein OLED vorhanden')
    time.sleep_ms(1000)
